/**
* Nudsf_DataRepository
* Nudsf Data Repository Service. © 2021, 3GPP Organizational Partners (ARIB, ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved. 
*
* The version of the OpenAPI document: 1.1.0-alpha.2
* 
*
* NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
* https://openapi-generator.tech
* Do not edit the class manually.
*/

#include "PluginApi.hpp"
//#include "Helpers.h"
#include "logger.hpp"
#include <nlohmann/json.hpp>
#include "TransData.hpp"
#include <stdlib.h>

using json = nlohmann::json;

//using namespace org::openapitools::server::model;

namespace org {
namespace openapitools {
namespace server {
namespace api {

using namespace org::openapitools::server::model;



PluginApi::PluginApi(std::shared_ptr<Pistache::Rest::Router> rtr) { 
    router = rtr;
}

void PluginApi::init() {
    setupRoutes();
}

void PluginApi::setupRoutes() {
    using namespace Pistache::Rest;

    // Routes::Put(*router, base + "/:realmId/:storageId/records/:recordId", Routes::bind(&PluginApi::create_or_modify_record_handler, this));
    // Routes::Delete(*router, base + "/:realmId/:storageId/records/:recordId", Routes::bind(&PluginApi::delete_record_handler, this));
    // Routes::Get(*router, base + "/:realmId/:storageId/records/:recordId/meta", Routes::bind(&PluginApi::get_meta_handler, this));
    // Routes::Get(*router, base + "/:realmId/:storageId/records/:recordId", Routes::bind(&PluginApi::get_record_handler, this));
    Routes::Put(*router, base + "/:assoid/:stream", Routes::bind(&PluginApi::N2_trans_handler, this));
    // Routes::Patch(*router, base + "/:realmId/:storageId/records/:recordId/meta", Routes::bind(&PluginApi::update_meta_handler, this));

    // Default handler, called when a route is not found
    //router->addCustomHandler(Routes::bind(&PluginApi::record_crud_api_default_handler, this));
}
void PluginApi::N2_trans_handler(const Pistache::Rest::Request &request, Pistache::Http::ResponseWriter response) {
    // Getting the path params
    auto assoc_id = request.param(":assoid").as<std::uint32_t>();
    auto stream = request.param(":stream").as<std::uint16_t>();
    
    Logger::plugin_server().info("--Put!--assoc_id = (%d), stream = (%d)",assoc_id,stream);


    // SubscriptionData subscriptionData;
    TransData transdata;
    std::cout<<request.body()<<std::endl;
    try {
        nlohmann::json::parse(request.body()).get_to(transdata);
        this->n2_trans_to_gnb(assoc_id,stream,transdata,response);
    } catch (nlohmann::detail::exception &e) {
        //send a 400 error
        response.send(Pistache::Http::Code::Bad_Request, e.what());
        return;
    } catch (Pistache::Http::HttpError &e) {
        response.send(static_cast<Pistache::Http::Code>(e.code()), e.what());
        return;
    } catch (std::exception &e) {
        //send a 500 error
        response.send(Pistache::Http::Code::Internal_Server_Error, e.what());
        return;
    }

}

}
}
}
}


