#include "plugin_app.hpp"
#include "sctp_server.hpp"
#include "plugin_config.hpp"
#include <curl/curl.h>
#include <nlohmann/json.hpp>
#include "logger.hpp"
using namespace std;
using namespace sctp;
using namespace config;
extern sctp_server* sctp_s_38412;
extern plugin_config plugin_cfg;



namespace amf_application{

plugin_app::plugin_app() {}
plugin_app::~plugin_app() {}
void octet_stream_2_hex_stream(uint8_t* buf, int len, std::string& out) {
  out       = "";
  char* tmp = (char*) calloc(1, 2 * len * sizeof(uint8_t) + 1);
  for (int i = 0; i < len; i++) {
    sprintf(tmp + 2 * i, "%02x", buf[i]);
  }
  tmp[2 * len] = '\0';
  out          = tmp;
  printf("n1sm buffer: %s\n", out.c_str());
}
static std::size_t callback(
    const char* in, std::size_t size, std::size_t num, std::string* out) {
  const std::size_t totalBytes(size * num);
  out->append(in, totalBytes);
  return totalBytes;
}
void plugin_app::handle_receive(
    bstring payload, sctp_assoc_id_t assoc_id, sctp_stream_id_t stream,
    sctp_stream_id_t instreams, sctp_stream_id_t outstreams)
{
    printf("使用http发送到amf\n");
    Logger::plugin_sbi().debug("receive n2 from gnb then Send N2 message to AMF");
    std::string ngapmsg;
    octet_stream_2_hex_stream((uint8_t*) bdata(payload), blength(payload), ngapmsg);
    Logger::sctp().debug(
        "[Assoc ID %d] Sending buffer %p of %d bytes on stream %d,ngapmsg length %d ",
        assoc_id, bdata(payload), blength(payload), stream,ngapmsg.length());
    
    nlohmann::json json_data = {};
    json_data["n2_data"] = ngapmsg;


    std::string url  =
        "http://" + std::string(plugin_cfg.nrf.addr4.c_str()) +
        ":" + std::to_string(plugin_cfg.nrf.port) + "/namf-comm/v1/plugin_n2/" +
        to_string (assoc_id ) + "/" + to_string (stream) ;

      Logger::plugin_sbi().debug(
          "Send N2 message to AMF , AMF URL %s", url.c_str());

    std::string body = json_data.dump();
    Logger::plugin_sbi().debug(
         "Send N2 message to AMF , msg body: \n %s", body.c_str());

     curl_global_init(CURL_GLOBAL_ALL);
     CURL* curl = curl = curl_easy_init();

     if (curl) {
        CURLcode res               = {};
        struct curl_slist* headers = nullptr;
        // std::string content_type = "content-type: multipart/related; boundary=" +
        //                        std::string(CURL_MIME_BOUNDARY);
        // headers = curl_slist_append(headers, content_type.c_str());
        headers = curl_slist_append(headers, "content-type: application/json");
        curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
        curl_easy_setopt(curl, CURLOPT_URL, url.c_str());
        curl_easy_setopt(curl, CURLOPT_HTTPGET, 1);
        curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "PUT");
        curl_easy_setopt(curl, CURLOPT_TIMEOUT_MS, AMF_CURL_TIMEOUT_MS);

            // Response information.
        long httpCode = {0};
        std::unique_ptr<std::string> httpData(new std::string());
        //std::unique_ptr<std::string> httpHeaderData(new std::string());
         // Hook up data handling function.
        curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, &callback);
        curl_easy_setopt(curl, CURLOPT_WRITEDATA, httpData.get());
       // curl_easy_setopt(curl, CURLOPT_HEADERDATA, httpHeaderData.get());
        curl_easy_setopt(curl, CURLOPT_POSTFIELDSIZE, body.length());
        //curl_easy_setopt(curl, CURLOPT_POSTFIELDS, body_data);
        curl_easy_setopt(curl, CURLOPT_POSTFIELDS, body.c_str());
        res = curl_easy_perform(curl);
        curl_easy_getinfo(curl, CURLINFO_RESPONSE_CODE, &httpCode);

    //     // Response information.
    //     long httpCode = {0};
    //     std::unique_ptr<std::string> httpData(new std::string());
    //     curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, &callback);
    //     curl_easy_setopt(curl, CURLOPT_WRITEDATA, httpData.get());
    //     curl_easy_setopt(curl, CURLOPT_POSTFIELDSIZE, body.length());
    //     curl_easy_setopt(curl, CURLOPT_POSTFIELDS, body.c_str());
    //     res = curl_easy_perform(curl);
    //     curl_easy_getinfo(curl, CURLINFO_RESPONSE_CODE, &httpCode);

        Logger::plugin_sbi().debug("Send NGAP message to AMF, response from AMF, HTTP Code: %d", httpCode);
        if (static_cast<http_response_codes_e>(httpCode) ==http_response_codes_e::HTTP_RESPONSE_CODE_0) {
            Logger::plugin_sbi().info( "Cannot get response when calling %s", url.c_str());
            // free curl before returning
            curl_slist_free_all(headers);
            curl_easy_cleanup(curl);
            return;
        }
        if (static_cast<http_response_codes_e>(httpCode) ==http_response_codes_e::HTTP_RESPONSE_CODE_200_OK) {
            Logger::plugin_sbi().info("sending successful when calling %s", url.c_str());
            curl_slist_free_all(headers);
            curl_easy_cleanup(curl);
            return;
        }
        curl_global_cleanup();

    
    }

}
}//namespace
    //     /




    //     Logger::smf_sbi().debug(
    //         "NF Instance Registration, response from NRF, HTTP Code: %d", httpCode);

    //     if (static_cast<http_response_codes_e>(httpCode) ==
    //         http_response_codes_e::HTTP_RESPONSE_CODE_CREATED) {
    //     json response_data = {};
    //     try {
    //         response_data = json::parse(*httpData.get());
    //     } catch (json::exception& e) {
    //         Logger::smf_sbi().warn(
    //             "NF Instance Registration, could not parse json from the NRF "
    //             "response");
    //     }
    //     Logger::smf_sbi().debug(
    //         "NF Instance Registration, response from NRF, json data: \n %s",
    //         response_data.dump().c_str());

    //     // send response to APP to process
    //     std::shared_ptr<itti_n11_register_nf_instance_response> itti_msg =
    //         std::make_shared<itti_n11_register_nf_instance_response>(
    //             TASK_SMF_SBI, TASK_SMF_APP);
    //     itti_msg->http_response_code = httpCode;
    //     itti_msg->http_version       = msg->http_version;
    //     Logger::smf_app().debug("Registered SMF profile (from NRF)");
    //     itti_msg->profile.from_json(response_data);

    //     int ret = itti_inst->send_msg(itti_msg);
    //     if (RETURNok != ret) {
    //         Logger::smf_sbi().error(
    //             "Could not send ITTI message %s to task TASK_SMF_APP",
    //             itti_msg->get_msg_name());
    //     }
    //     } else {
    //     Logger::smf_sbi().warn(
    //         "NF Instance Registration, could not get response from NRF");
    //     }

    //     curl_slist_free_all(headers);
    //     curl_easy_cleanup(curl);
    // }
    // curl_global_cleanup();
    

